-- SwitchView UI version 0.1.2 by VitaHEX
-- https://www.patreon.com/vitahex
local working_dir = "ux0:/app"
function System.currentDirectory(dir)
	if dir == nil then
		return working_dir
	else
		working_dir = dir
	end
end
Network.init()
Sound.init()
local click = Sound.open("app0:/UI/click1.wav")
local imgTmp = Graphics.loadImage("app0:/UI/noimg.png")
local imgCart = Graphics.loadImage("app0:/UI/cart.png")
local imgAvatar = Graphics.loadImage("app0:/AVATARS/AV01.png")
local imgCont = Graphics.loadImage("app0:/UI/cont.png")
local btnX = Graphics.loadImage("app0:/UI/x.png")
local btnO = Graphics.loadImage("app0:/UI/o.png")
local imgWifi = Graphics.loadImage("app0:/UI/wifi.png")
local imgSet = Graphics.loadImage("app0:/UI/sysset.png")
local imgBattery = Graphics.loadImage("app0:/UI/bat.png")
local btnMenu1 = Graphics.loadImage("app0:/UI/btm1.png")
local btnMenu2 = Graphics.loadImage("app0:/UI/btm2.png")
local btnMenu3 = Graphics.loadImage("app0:/UI/btm3.png")
local btnMenu4 = Graphics.loadImage("app0:/UI/btm4.png")
local btnMenu5 = Graphics.loadImage("app0:/UI/btm5.png")
local btnMenu6 = Graphics.loadImage("app0:/UI/btm6.png")
local btnMenuSel = Graphics.loadImage("app0:/UI/selct.png")

local img_path = ""

local fnt = Font.load("app0:/UI/font.ttf")
local bottomMenu = false
local menuSel = 1
local menuX = 0
local showMenu = 0
local menuY = 0
local appversion = "0.1.2"

info = System.extractSfo("app0:/sce_sys/param.sfo")
app_version = info.version
app_title = info.title
app_category = info.category
app_titleid = info.titleid

function OneshotPrint(my_func)
	my_func()
	Screen.flip()
	my_func()
	Screen.flip()
	my_func()
end

-- Speed related settings
local cpu_speed = 333
System.setBusSpeed(222)
System.setGpuSpeed(222)
System.setGpuXbarSpeed(166)
System.setCpuSpeed(cpu_speed)

-- Functions used by filebrowser
local function CropPrint(x, y, text, color, icon)
	Graphics.setImageFilters(icon, FILTER_LINEAR, FILTER_LINEAR)
	Graphics.drawScaleImage(x, y, icon, 1.5, 1.5)
end
function TableConcat(t1,t2)
    for i=1,#t2 do
        t1[#t1+1] = t2[i]
    end
    return t1
end

function SelectBottomMenu()
	if menuSel==1 then
	System.executeUri("wbapp0:")
	elseif menuSel==2 then
	System.executeUri("psns:")
	elseif menuSel==3 then
	System.executeUri("photo:")
	elseif menuSel==4 then
	System.executeUri("scecomboplay:")
	elseif menuSel==5 then
	System.executeUri("settings_dlg:")
	elseif menuSel==6 then
	Graphics.freeImage(imgTmp)
	Graphics.freeImage(imgCart)
	Graphics.freeImage(imgAvatar)
	Graphics.freeImage(btnX)
	Graphics.freeImage(btnO)
	Graphics.freeImage(imgBattery)
	Graphics.freeImage(imgWifi)
	Graphics.freeImage(btnMenu1)
	Graphics.freeImage(btnMenu2)
	Graphics.freeImage(btnMenu3)
	Graphics.freeImage(btnMenu4)
	Graphics.freeImage(btnMenu5)
	Graphics.freeImage(btnMenu6)
	Graphics.freeImage(btnMenuSel)
	System.exit()
	end
end

function listDirectory(dir)
	dir = System.listDirectory(dir)
	folders_table = {}
	files_table = {}
	for i,file in pairs(dir) do
		if file.directory then
			table.insert(folders_table,file)
		end
		img_path = "ur0:/appmeta/" .. file.name .. "/icon0.png"
			if not pcall(loadImage, img_path) then 
				imgTmp = Graphics.loadImage("app0:/UI/noimg.png")
				file.icon=imgTmp
				table.insert(files_table, 4,file.icon)
			else
				imgTmp = Graphics.loadImage(img_path)
				file.icon=imgTmp
				table.insert(files_table, 4,file.icon)
			end
	end
	table.sort(files_table, function (a, b) return (a.name:lower() < b.name:lower() ) end)
	table.sort(folders_table, function (a, b) return (a.name:lower() < b.name:lower() ) end)
	return_table = TableConcat(folders_table,files_table)
	return return_table
end

function loadImage (img_path) 
	imgTmp = Graphics.loadImage(img_path) 
end

-- Starting filebrowser
files_table = listDirectory(System.currentDirectory())
local master_index = 0
local p = 1
local oldpad = 0
local delayTouch = 8.0

-- Init a couple of colors
local black = Color.new(0,0,0)
local grey = Color.new(45,45,45) 
local lightgrey = Color.new(77,77,77) 
local white = Color.new(255,255,255)
local red = Color.new(255, 0, 0)
local yellow = Color.new(255, 255, 0)
local blue = Color.new(67,178,255)
local cyan = Color.new(0,254,202)
local bg = Color.new(153,217,234)

local xstart = 0
local ystart = 0
local touchdown = 0
	
-- Main loop
while true do
		
	-- Reading input
	pad = Controls.read()
	
	-- touch input
	x1,y1 = Controls.readTouch() 
	
	-- Initializing rendering
	Graphics.initBlend()
	Screen.clear(grey) 

	if x1 ~= nil then
		-- on touch down
		if touchdown==0 and delayTouch<0.5 then
			touchdown=1
			xstart=x1
			delayTouch=10
		end
		if touchdown>0 and delayTouch>0.5 then 
			if x1>xstart+80 then
				touchdown=2
				xstart=x1
				p = p-1
				if (p<=master_index) then 
				master_index = p-1
			end
			elseif x1<xstart-80 then
				touchdown=2
				xstart=x1
				p = p+1
				master_index = p-3
			end
		end

	end

	if delayTouch > 0 then
		delayTouch = delayTouch -0.1 
	else
		delayTouch=0
		touchdown=0
	end

	Graphics.drawLine(21, 940, 489, 489, white)
	
	if showMenu == 0 then
	Font.setPixelSizes(fnt, 22)
	h,m,s = System.getTime()
	Font.print(fnt, 726, 34, string.format("%02d:%02d",h,m), white)--Draw time
	life = System.getBatteryPercentage()
	Font.print(fnt, 830, 34, life .. "%", white)--Draw battery
	Graphics.drawImage(888, 41, imgBattery)
	Graphics.fillRect(891, 891+(life/5.2), 45, 53, white)
	Graphics.drawImage(43, 28, imgAvatar)
	Graphics.drawImage(45, 496, imgCont)
	if Network.isWifiEnabled() then
		Graphics.drawImage(800, 38, imgWifi)
	end

	
	Graphics.drawImage(850, 507, btnX)
	Font.print(fnt, 878, 503, "Start", white)
	if bottomMenu == false then 
	Graphics.drawImage(27, 108, imgCart)
	Font.setPixelSizes(fnt, 27)
	Font.print(fnt, 60, 104, app_title, blue)--Draw title
	else
	Font.setPixelSizes(fnt, 27)
	if menuSel==1 then
	menuX=240-2
	Font.print(fnt, menuX+8, 452, "News", blue)
	elseif menuSel==2 then
	menuX=322-2	
	Font.print(fnt, menuX+4, 452, "Store", blue)
	elseif menuSel==3 then
	menuX=404-2	
	Font.print(fnt, menuX+5, 452, "Album", blue)
	elseif menuSel==4 then
	menuX=486-2	
	Font.print(fnt, menuX-5, 452, "Controlls", blue)
	elseif menuSel==5 then
	menuX=568-2	
	Font.print(fnt, menuX-30, 452, "System Settings", blue)
	elseif menuSel==6 then
	menuX=650-2	
	Font.print(fnt, menuX+16, 452, "Exit", blue)
	end
	Graphics.drawImage(menuX, 378-2, btnMenuSel)

	end
	Graphics.drawImage(240, 378, btnMenu1)
	Graphics.drawImage(322, 378, btnMenu2)
	Graphics.drawImage(404, 378, btnMenu3)
	Graphics.drawImage(486, 378, btnMenu4)
	Graphics.drawImage(568, 378, btnMenu5)
	Graphics.drawImage(650, 378, btnMenu6)
		
		-- Drawing Filebrowser
		base_y = 85
		for l, file in pairs(files_table) do
			if (base_y > 960) then
				break
			end
			if (l >= master_index) then
				if (l==p) then
					base_y2 = base_y
					if (base_y) == 0 then
						base_y = 50
				end
					if bottomMenu == false then 
					Graphics.fillRect(base_y-6,base_y+198,152-6,152+198,blue) 
					end
					color = red
					if (base_y) == 2 then
						base_y = 50
					end
				else
					color = white
				end
				CropPrint(base_y,152,file.name,color, file.icon)
				base_y = base_y + 200
			end
		end
	end
	if showMenu == 1 then 
		-- System Settings Menu
		Graphics.drawImage(45, 20, imgSet)
		Font.setPixelSizes(fnt, 32)
		Font.print(fnt, 96, 18, "System Settings", white)
		Graphics.drawLine(21, 940, 65, 65, white)
		Graphics.drawImage(45, 496, imgCont)
		Font.setPixelSizes(fnt, 22)
		Graphics.drawImage(750, 507, btnO)
		Graphics.drawImage(850, 507, btnX)
		Font.print(fnt, 778, 503, "Back", white)
		Font.print(fnt, 878, 503, "Start", white)
		
		--selection
		Graphics.fillRect(46,288,74+(menuY*54),128+(menuY*54),blue)
		Graphics.fillRect(49,285,77+(menuY*54),125+(menuY*54),black)
		
		--Graphics.fillRect(60,63,132,172,cyan)
		Font.setPixelSizes(fnt, 27)
		Font.print(fnt, 70, 84, "Themes", white)
		Font.print(fnt, 70, 134, "About", white)
		
		-- Themes menu
		if menuY == 0 then
			Graphics.drawLine(350, 895, 100, 100, lightgrey)
			Graphics.fillRect(364-1,435+1,111-1,154+1,lightgrey)
			Graphics.fillRect(364,435,111,154,black)
			Graphics.drawLine(350, 895, 168, 168, lightgrey)
			--Graphics.fillRect(364-1,435+1,111-1+68,154+1+68,lightgrey)
			--Graphics.fillRect(364,435,111+68,154+68,white)
			--Graphics.drawLine(350, 895, 168+68, 168+68, lightgrey)
			Font.setPixelSizes(fnt, 27)
			Font.print(fnt, 445, 111, "Basic Black", white)
			--Font.print(fnt, 445, 111+68, "Basic White", white)
		end
		-- About menu
		if menuY == 1 then
			Font.setPixelSizes(fnt, 27)
			Font.print(fnt, 360, 100, "SwitchView UI\nVersion " .. appversion .. "\n\nDeveloped by VitaHEX\nwww.patreon.com/vitahex", white)
		end
	end
	-- Terminating rendering phase
	Graphics.termBlend()
	
		-- Filebrowser navigation
		if (Controls.check(pad,SCE_CTRL_CROSS) and not Controls.check(oldpad,SCE_CTRL_CROSS)) then
			if showMenu == 0 then
				if bottomMenu == false then
					System.launchApp(files_table[p].name)
				else
					SelectBottomMenu()
				end
			end	
		elseif (Controls.check(pad,SCE_CTRL_CIRCLE)) and not (Controls.check(oldpad,SCE_CTRL_CIRCLE)) then
			if showMenu == 1 then 
			showMenu = 0
			Sound.play(click, NO_LOOP)
			end
		elseif (Controls.check(pad,SCE_CTRL_START)) and not (Controls.check(oldpad,SCE_CTRL_START)) then
			if showMenu == 0 then 
			showMenu = 1
			Sound.play(click, NO_LOOP)
			end
		elseif (Controls.check(pad,SCE_CTRL_LEFT)) and not (Controls.check(oldpad,SCE_CTRL_LEFT)) then
			if bottomMenu == false and showMenu == 0 then 
			Sound.play(click, NO_LOOP)
			p = p - 1
			if p>0 then
			info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
			app_title = info.title
			end	
			if (p<=master_index) then 
				master_index = p-1
			end
			else
				if showMenu == 0 then
				Sound.play(click, NO_LOOP)
				menuSel = menuSel - 1
				if (menuSel<1) then
				menuSel=6
				end
				end
			end
		elseif (Controls.check(pad,SCE_CTRL_LTRIGGER)) and not (Controls.check(oldpad,SCE_CTRL_LTRIGGER)) then
			if bottomMenu == false and showMenu == 0 then 
			Sound.play(click, NO_LOOP)
			p = p - 5
			if p>0 then
			info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
			app_title = info.title
			end	
			if (p<=master_index) then 
				master_index = p - 1
			end
			end
		elseif (Controls.check(pad,SCE_CTRL_RIGHT)) and not (Controls.check(oldpad,SCE_CTRL_RIGHT)) then
			if bottomMenu == false and showMenu == 0 then 
			Sound.play(click, NO_LOOP)
			p = p + 1
			if p<=#files_table then
			info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
			app_title = info.title
			end
			if (p >= master_index+3) then 
				master_index = p - 3
			end
			else
				if showMenu == 0 then
				Sound.play(click, NO_LOOP)
				menuSel = menuSel + 1
				if (menuSel>6) then
				menuSel=1
				end
				end
			end
		elseif (Controls.check(pad,SCE_CTRL_RTRIGGER)) and not (Controls.check(oldpad,SCE_CTRL_RTRIGGER)) then
			if bottomMenu == false and showMenu == 0 then 
			Sound.play(click, NO_LOOP)
			p = p + 5
			if p<=#files_table then
			info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
			app_title = info.title
			end
			if (p >= 3) then 
				master_index = p - 3
			end
			end
		elseif (Controls.check(pad,SCE_CTRL_UP)) and not (Controls.check(oldpad,SCE_CTRL_UP)) then
			if bottomMenu == true then 
				if showMenu == 0 then
					bottomMenu = false
					Sound.play(click, NO_LOOP)
				end
			end
			if showMenu == 1 then
			Sound.play(click, NO_LOOP)
				menuY = 0
			end
		elseif (Controls.check(pad,SCE_CTRL_DOWN)) and not (Controls.check(oldpad,SCE_CTRL_DOWN)) then
			if bottomMenu == false then 
				if showMenu == 0 then
					bottomMenu = true 
					Sound.play(click, NO_LOOP)
				end
			end
			if showMenu == 1 then
			Sound.play(click, NO_LOOP)
				menuY = 1
			end
		end
		
		if p < 1 then
			p = #files_table
			if p >= 4 then 
				master_index = p - 3
			end
			info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
			app_title = info.title
		elseif p > #files_table then
			master_index = 0
			p = 1
			info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
			app_title = info.title
		end

	-- Refreshing screen and oldpad
	Screen.flip()
	oldpad = pad
end
